/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <constructs.h>

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{

int argcount=1,i,j,k,l,m,n,nmax,newworld;

double **life,**save;
double conc,delta=1.0, velo,phi;

double vxl,vxr,vyu,vyd,vlen;
int eusteps, outcount;

sscanf(argv[argcount++],"%d",&nmax);
sscanf(argv[argcount++],"%d",&newworld);
sscanf(argv[argcount++],"%lf",&velo);
sscanf(argv[argcount++],"%lf",&phi);

life = dmatrix(-1,nmax+1,-1,nmax+1);
save = dmatrix(-1,nmax+1,-1,nmax+1);

for (i=-1;i<=nmax+1;i++)
   for (j=-1;j<=nmax+1;j++)
   {
     save[i][j]=0.0;
     life[i][j]=0.0;
   }

/* Einlesen der Startwerte    */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     sscanf(argv[argcount++],"%lf",&conc);
     if (conc < 0.0) conc=0.0;
     life[i][j]=save[i][j]=conc;
   }


/* Bestimmung der Geschwindigkeit in die einzelnen Richtungen */
vxr=velo*cos(M_PI*phi/180.0);
vyu=velo*sin(M_PI*phi/180.0);

/* an das Upstream schema anpassen */
if (vxr>0) {vxl=0;} else {vxl=-vxr;vxr=0;}
if (vyu>0) {vyd=0;} else {vyd=-vyu;vyu=0;}


/* Advektion*/
for (i=0;i<=nmax;i++)
    for (j=0;j<=nmax;j++)
    {
    /* Bestimmung der Nachbarindizes */
      k= i-1;
      l= j-1;
      m= i+1;
      n= j+1;

      if (newworld==1) {
    /* Setzen der Randindizes */
         if (i==0) k=nmax;
         if (i==nmax) m=0;
         if (j==0) l=nmax;
         if (j==nmax) n=0;
      }

      conc      = save[i][j];

      life[i][j] -= (vxr+vxl+vyu+vyd)*conc*delta;
      life[k][j] += vxl*conc*delta;
      life[i][n] += vyd*conc*delta;
      life[m][j] += vxr*conc*delta;
      life[i][l] += vyu*conc*delta;
}



/* Ausgabe fuer Tcl */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
   if (life[i][j]<0.0) life[i][j]=0.0;
   printf("%f ",(float) life[i][j]);
   }

   printf("\n");

   fflush(stdout);


return(0);
}
