/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "constructs.h"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{

int argcount=1,i,j,k,l,m,n,nmax,newworld,fill,schlag;

double **life,**save, **tree;
double kaefer,baum,delta;


double eps0,epsr,alfa,beta,mue,r,rs,salter,K,M,N;
int eusteps, outcount;

sscanf(argv[argcount++],"%d",&nmax);
sscanf(argv[argcount++],"%d",&newworld);
sscanf(argv[argcount++],"%d",&schlag);

sscanf(argv[argcount++],"%lf",&eps0);
sscanf(argv[argcount++],"%lf",&epsr);
sscanf(argv[argcount++],"%lf",&r);
sscanf(argv[argcount++],"%lf",&rs);
sscanf(argv[argcount++],"%lf",&mue);
sscanf(argv[argcount++],"%lf",&alfa);
sscanf(argv[argcount++],"%lf",&beta);
sscanf(argv[argcount++],"%lf",&K);
sscanf(argv[argcount++],"%lf",&M);
sscanf(argv[argcount++],"%lf",&N);
sscanf(argv[argcount++],"%lf",&salter);


life = dmatrix(-1,nmax+1,-1,nmax+1);
save = dmatrix(-1,nmax+1,-1,nmax+1);
tree = dmatrix(-1,nmax+1,-1,nmax+1);

for (i=-1;i<=nmax+1;i++)
   for (j=-1;j<=nmax+1;j++)
   {
     save[i][j]=0.0;
     life[i][j]=0.0;
   }
/* Einlesen der Startwerte    */

for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     sscanf(argv[argcount++],"%lf",&kaefer);
     if (kaefer < 0.0) kaefer=0.0;
     life[i][j]=save[i][j]=kaefer;
   }

for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     sscanf(argv[argcount++],"%lf",&baum);
     if (baum < 0.0) baum=0.0;
     tree[i][j]=baum;
   }


/* Wachstumsteil (B�ume und K�fer) */
/*Zeitloop Zeit in Jahren--------------------------------------------------------------------*/
delta =0.01;

for (k=1;k<=10;k++)
{
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     kaefer=life[i][j];
     baum  =tree[i][j];

     /*K�ferwachstum*/
     life[i][j] += delta*(r*baum*kaefer*(1.0-kaefer/K) - mue*kaefer*kaefer/(kaefer*kaefer+M*M));

     /*Baumalter*/
     tree[i][j] += delta*(alfa*(1.0-baum) - beta*pow(kaefer/K,N)*baum);

     /* Schlag alter B�ume*/
     if (schlag==1 && tree[i][j] > salter) tree[i][j] += -rs*baum;
   }

/* Wanderung der K�fer */
for (i=0;i<=nmax;i++)
    for (j=0;j<=nmax;j++)
    {
    /* Bestimmung der Nachbarindizes */
      k= i-1;
      l= j-1;
      m= i+1;
      n= j+1;

      if (newworld==1) {
    /* Setzen der Randindizes */
         if (i==0) k=nmax;
         if (i==nmax) m=0;
         if (j==0) l=nmax;
         if (j==nmax) n=0;
      }

      kaefer      = save[i][j];

      life[i][j] -= 4.0*eps0*kaefer*delta;
      life[k][j] += eps0*(1.0-epsr)*kaefer*delta;
      life[i][n] += eps0*kaefer*delta;
      life[m][j] += eps0*(1.0+epsr)*kaefer*delta;
      life[i][l] += eps0*kaefer*delta;
}

}

/* Ausgabe fuer Tcl */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
   if (life[i][j]<0.0) life[i][j]=0.0;
   printf("%f ",(float) life[i][j]);
   }
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
   if (tree[i][j]<0.0) tree[i][j]=0.0;
   printf("%f ",(float) tree[i][j]);
   }
   printf("\n");

   fflush(stdout);


return(0);
}
