/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2004, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "constructs.h"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{

int argcount=1,i,j,k,l,m,n,nmax,newworld;

double **life,**save;
double conc,delta=1.0, D;

int eusteps, outcount;

sscanf(argv[argcount++],"%d",&nmax);
sscanf(argv[argcount++],"%d",&newworld);
sscanf(argv[argcount++],"%lf",&D);


life = dmatrix(-1,nmax+1,-1,nmax+1);
save = dmatrix(-1,nmax+1,-1,nmax+1);

for (i=-1;i<=nmax+1;i++)
   for (j=-1;j<=nmax+1;j++)
   {
     save[i][j]=0.0;
     life[i][j]=0.0;
   }

/* Einlesen der Startwerte    */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     sscanf(argv[argcount++],"%lf",&conc);
     if (conc < 0.0) conc=0.0;
     life[i][j]=save[i][j]=conc;
   }


/* Diffusion*/
for (i=0;i<=nmax;i++)
    for (j=0;j<=nmax;j++)
    {
    /* Bestimmung der Nachbarindizes */
      k= i-1;
      l= j-1;
      m= i+1;
      n= j+1;

      if (newworld==1) {
    /* Setzen der Randindizes */
         if (i==0) k=nmax;
         if (i==nmax) m=0;
         if (j==0) l=nmax;
         if (j==nmax) n=0;
      }

      conc      = save[i][j];

      life[i][j] -= 4.0*D*conc*delta;
      life[k][j] += D*conc*delta;
      life[i][n] += D*conc*delta;
      life[m][j] += D*conc*delta;
      life[i][l] += D*conc*delta;
}



/* Ausgabe fuer Tcl */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
   if (life[i][j]<0.0) life[i][j]=0.0;
   printf("%f ",(float) life[i][j]);
   }

   printf("\n");

   fflush(stdout);


return(0);
}
