/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2004, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "constructs.h"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{

int argcount=1,i,j,k,l,m,t,n,nmax,newworld;
double Da,Db,ma,mb,epsa,epsb,qa;
double **A,**saveA,**B,**saveB;
double acti,inhi,delta=0.01;

int eusteps, outcount;

sscanf(argv[argcount++],"%d",&nmax);
sscanf(argv[argcount++],"%d",&newworld);
sscanf(argv[argcount++],"%lf",&Db);
sscanf(argv[argcount++],"%lf",&ma);
sscanf(argv[argcount++],"%lf",&mb);
sscanf(argv[argcount++],"%lf",&epsa);
sscanf(argv[argcount++],"%lf",&epsb);
sscanf(argv[argcount++],"%lf",&qa);

Da=Db/qa;

A = dmatrix(-1,nmax+1,-1,nmax+1);/*Aktivator*/
saveA = dmatrix(-1,nmax+1,-1,nmax+1);
B = dmatrix(-1,nmax+1,-1,nmax+1);/*Inhibitor*/
saveB = dmatrix(-1,nmax+1,-1,nmax+1);/*Inhibitor*/

for (i=-1;i<=nmax+1;i++)
   for (j=-1;j<=nmax+1;j++)
   {
     saveA[i][j]=0.0;
     saveB[i][j]=0.0;
     A[i][j]=0.0;
     B[i][j]=0.0;
   }

/* Einlesen der Startwerte    */
/* Aktivator */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     sscanf(argv[argcount++],"%lf",&acti);
     if (acti < 0.0) acti=0.0;
     A[i][j]=saveA[i][j]=acti;
   }
/* Inhibitor */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     sscanf(argv[argcount++],"%lf",&inhi);
     if (inhi < 0.0) inhi=0.0;
     B[i][j]=saveB[i][j]=inhi;
   }


/* 10 Schritte, dann erst Ausgabe */
for (t=0;t<10;t++)
{
/* Reaction and Diffusion*/
for (i=0;i<=nmax;i++)
    for (j=0;j<=nmax;j++)
    {
    /* Bestimmung der Nachbarindizes */
      k= i-1;
      l= j-1;
      m= i+1;
      n= j+1;

      if (newworld==1) {
    /* Setzen der Randindizes */
         if (i==0) k=nmax;
         if (i==nmax) m=0;
         if (j==0) l=nmax;
         if (j==nmax) n=0;
      }


/* Reaction Activator */
A[i][j] +=(A[i][j]*A[i][j]/B[i][j] + epsa  -ma*A[i][j])*delta;

/* Reaction Inhibitor */
B[i][j] +=(A[i][j]*A[i][j] +epsb -mb*B[i][j])*delta;

/* Diffusion Activator */
      acti      = saveA[i][j];

      A[i][j] -= 4.0*Da*acti*delta;
      A[k][j] += Da*acti*delta;
      A[i][n] += Da*acti*delta;
      A[m][j] += Da*acti*delta;
      A[i][l] += Da*acti*delta;

/* Diffusion Inhibitor */
      inhi      = B[i][j];

      B[i][j] -= 4.0*Db*inhi*delta;
      B[k][j] += Db*inhi*delta;
      B[i][n] += Db*inhi*delta;
      B[m][j] += Db*inhi*delta;
      B[i][l] += Db*inhi*delta;


}

}


/* Ausgabe fuer Tcl */
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
   if (A[i][j]<0.0) A[i][j]=0.0;
   printf("%f ",(float) A[i][j]);
   }


for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
   if (B[i][j]<0.0) B[i][j]=0.0;
   printf("%f ",(float) B[i][j]);
   }

   printf("\n");

   fflush(stdout);


return(0);
}
