/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2004, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "constructs.h"

int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
int argcount=1,i,j,k,l,m,n,nmax,newworld,fill,neighbors,count=0;
int **life,**save;

sscanf(argv[argcount++],"%d",&nmax);
sscanf(argv[argcount++],"%d",&newworld);
sscanf(argv[argcount++],"%d",&l);
sscanf(argv[argcount++],"%d",&fill);
sscanf(argv[argcount++],"%d",&neighbors);

srand(l);

life = imatrix(-1,nmax+1,-1,nmax+1);
save = imatrix(-1,nmax+1,-1,nmax+1);

for (i=-1;i<=nmax+1;i++)
   for (j=-1;j<=nmax+1;j++)
   {
     save[i][j]=0;
     life[i][j]=0;
   }

for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {
     k = argcount+i*(nmax+1)+j;
     sscanf(argv[k],"%d",&m);
     life[i][j]=save[i][j]=m;
     if (m>=neighbors) count++;
   }

if (count!=0)
{
   for (i=0;i<=nmax;i++)
      for (j=0;j<=nmax;j++)
      {
/* Bestimmung der Nachbarindizes */
      k= i-1;
      l= j-1;
      m= i+1;
      n= j+1;

      if (newworld==1) {
/* Setzen der Randindizes */
         if (i==0) k=nmax;
         if (i==nmax) m=0;
         if (j==0) l=nmax;
         if (j==nmax) n=0;
      }

      if (save[i][j]>=neighbors)
      {
         life[i][l]++;
         life[i][n]++;
         life[k][j]++;
         life[m][j]++;
	 if (neighbors>4)
	 {
            life[k][l]++;
            life[m][n]++;
            life[k][n]++;
            life[m][l]++;
	 }
         
       
        life[i][j]= life[i][j]-neighbors+fill;
       }
      }
} else {
  i = (int) (nmax+1)*(rand()/(float)RAND_MAX);
  j = (int) (nmax+1)*(rand()/(float)RAND_MAX);
  life[i][j]++;
}
for (i=0;i<=nmax;i++)
   for (j=0;j<=nmax;j++)
   {   
   printf("%d ",life[i][j]);
   }
   printf("\n");
return(0);
}
