/***********************************************************************
**                                                                    **
** CEMoS Version 4.1 Copyright (C) 2012, Frank Hamberg, Cora Kohlmeier**
**                                                                    **
** last change 2003/05/19 -> implemented i3tensor /fh                 **
**                                                                    **
***********************************************************************/
#ifndef __CONSTRUCTS_H
#define __CONSTRUCTS_H

typedef float real;

static float sqrarg;
#define SQR(a) ((sqrarg=(a)) == 0.0 ? 0.0 : sqrarg*sqrarg)

static double dsqrarg;
#define DSQR(a) ((dsqrarg=(a)) == 0.0 ? 0.0 : dsqrarg*dsqrarg)

static double dmaxarg1,dmaxarg2;
#define DMAX(a,b) (dmaxarg1=(a),dmaxarg2=(b),(dmaxarg1) > (dmaxarg2) ?\
        (dmaxarg1) : (dmaxarg2))

static double dminarg1,dminarg2;
#define DMIN(a,b) (dminarg1=(a),dminarg2=(b),(dminarg1) < (dminarg2) ?\
        (dminarg1) : (dminarg2))

static float maxarg1,maxarg2;
#define FMAX(a,b) (maxarg1=(a),maxarg2=(b),(maxarg1) > (maxarg2) ?\
        (maxarg1) : (maxarg2))

static float minarg1,minarg2;
#define FMIN(a,b) (minarg1=(a),minarg2=(b),(minarg1) < (minarg2) ?\
        (minarg1) : (minarg2))

static long lmaxarg1,lmaxarg2;
#define LMAX(a,b) (lmaxarg1=(a),lmaxarg2=(b),(lmaxarg1) > (lmaxarg2) ?\
        (lmaxarg1) : (lmaxarg2))

static long lminarg1,lminarg2;
#define LMIN(a,b) (lminarg1=(a),lminarg2=(b),(lminarg1) < (lminarg2) ?\
        (lminarg1) : (lminarg2))

static int imaxarg1,imaxarg2;
#define IMAX(a,b) (imaxarg1=(a),imaxarg2=(b),(imaxarg1) > (imaxarg2) ?\
        (imaxarg1) : (imaxarg2))

static int iminarg1,iminarg2;
#define IMIN(a,b) (iminarg1=(a),iminarg2=(b),(iminarg1) < (iminarg2) ?\
        (iminarg1) : (iminarg2))

#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))


extern void std_error(const char error_text[]);
extern real *vector(long first, long last);
extern float *fvector(long first, long last);
extern int *ivector(long first, long last);
extern unsigned char *cvector(long first, long last);
extern unsigned long *lvector(long first, long last);
extern double *dvector(long first, long last);
extern float **fmatrix(long first_row, long last_row, long first_col, long last_col);
extern real **matrix(long first_row, long last_row, long first_col, long last_col);
extern double **dmatrix(long first_row, long last_row, long first_col, long last_col);
extern int **imatrix(long first_row, long last_row, long first_col, long last_col);
extern long int **lmatrix(long first_row, long last_row, long first_col, long last_col);
extern float **submatrix(float **in_ptr, long old_first_row, long old_last_row, long old_first_col, long old_last_col,long new_first_row, long new_first_col);
extern float **convert_matrix(float *in_ptr, long first_row, long last_row, long first_col, long last_col);
extern float ***f3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern double ***d3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern real ***r3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern int ***i3tensor(long first_row, long last_row, long first_col, long last_col, long first_lay, long last_lay);
extern real **r3tensor_submatrix(real ***in_ptr, long newr, long first_col, long last_col, long first_lay, long last_lay);
extern int **i3tensor_submatrix(int ***in_ptr, long newr, long first_col, long last_col, long first_lay, long last_lay);
extern void free_vector(real *v, long first, long last);
extern void free_fvector(float *v, long first, long last);
extern void free_ivector(int *v, long first, long last);
extern void free_cvector(unsigned char *v, long first, long last);
extern void free_lvector(unsigned long *v, long first, long last);
extern void free_dvector(double *v, long first, long last);
extern void free_matrix(real **m, long first_row, long last_row, long first_col, long last_col);
extern void free_fmatrix(float **m, long first_row, long last_row, long first_col, long last_col);
extern void free_dmatrix(double **m, long first_row, long last_row, long first_col, long last_col);
extern void free_imatrix(int **m, long first_row, long last_row, long first_col, long last_col);
extern void free_lmatrix(long int **m, long first_row, long last_row, long first_col, long last_col);
extern void free_submatrix(float **b, long first_row, long last_row, long first_col, long last_col);
extern void free_convert_matrix(float **b, long first_row, long last_row, long first_col, long last_col);
extern void free_f3tensor(float ***t, long first_row, long last_row, long first_col, long last_col,long first_lay, long last_lay);
extern void free_i3tensor(int ***t, long first_row, long last_row, long first_col, long last_col,long first_lay, long last_lay);
extern void free_tensor(real ***t, long first_row, long last_row, long first_col, long last_col,	long first_lay, long last_lay);
#endif /* __CONSTRUCTS_H */
