/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <math.h>
#include "constructs.h"
#define byte unsigned char

int main(int argc, char *argv[]);
int main(int argc, char *argv[])
{
FILE *pict,*colt;

int ixsize,iysize,i,j,l,col,iter;
double **bild;
double k,kmax,kmin;
double xsize,ysize,old_xsize,old_ysize;
double deltx,delty,xmax,xmin,ymax,ymin,d,dmin,xd,yd;
double imgs;

byte r[255],g[255],b[255];
int temp,max_col;
double bxmin,bxmax,bymin,bymax,bxd,byd;
double julx,july;
double zre,zim,z0re,z0im,z2re,z2im,ar,br;
char test;

char filename[256];
char colors[256];

sscanf(argv[1],"%lf",&xmin);
sscanf(argv[2],"%lf",&xmax);
sscanf(argv[3],"%lf",&ymin);
sscanf(argv[4],"%lf",&ymax);
sscanf(argv[5],"%lf",&bxmin);
sscanf(argv[6],"%lf",&bxmax);
sscanf(argv[7],"%lf",&bymin);
sscanf(argv[8],"%lf",&bymax);
sscanf(argv[9],"%lf",&old_xsize);
sscanf(argv[10],"%lf",&old_ysize);
sscanf(argv[11],"%lf",&julx);
sscanf(argv[12],"%lf",&july);
sscanf(argv[13],"%d",&iter);
sscanf(argv[14],"%lf",&imgs);
sprintf(colors,"%s",argv[15]);
sprintf(filename,"%s",argv[16]);

xd=xmax-xmin;
yd=ymax-ymin;

bxd=bxmax-bxmin;
byd=bymax-bymin;

ixsize=imgs;
iysize=imgs;

julx=xmin+xd*julx/old_xsize;
july=ymin+yd*(old_ysize-july)/old_ysize;

xmin=-2.0;
xmax=2.0;
ymin=-2.0;
ymax=2.0;

bild=dmatrix(0,ixsize,0,iysize);

deltx=(xmax-xmin)/ixsize;
delty=(ymax-ymin)/iysize;

colt=fopen(colors,"r");
l=0;
while ((test=fgetc(colt))!=EOF && l<255)
 {
 ungetc(test,colt);
 fscanf(colt,"%d",&temp);
 r[l]=(unsigned char) temp;
 fscanf(colt,"%d",&temp);
 g[l]=(unsigned char) temp;
 fscanf(colt,"%d",&temp);
 b[l]=(unsigned char) temp;
 l++;
 }
max_col=l-1;

kmax=-1;
kmin=max_col;

for (i=0;i<ixsize;i++)
  {
  zre=xmin+(double)i*deltx;
  
  for (j=0;j<iysize;j++)
    {
    zim=ymin+(double)j*delty;

/* Hier beginnt die Iteration */
    ar=zre*zre;
    br=zim*zim;
    z0re=zre;
    z0im=zim;
    k=0;
    for (l=0;l<iter;l++)
      {
      z2re=ar-br+julx;
      z2im=2.*z0re*z0im+july;

      if (((z2re-z0re)*(z2re-z0re)+(z2im-z0im)*(z2im-z0im))<1.e-12)
       {
       break;
       }

      ar=z2re*z2re;
      br=z2im*z2im;
      if ((ar+br)>=4.)
       {
       k=l;
       break;
       }
      z0re=z2re;
      z0im=z2im;
      }
/* Hier endet die Iteration */
    k=log(k+1);

    bild[i][iysize-j-1]=k;  
    kmax=DMAX(k,kmax);
    kmin=DMIN(kmin,k);
    }
  } 


d=(double) (max_col-1)/ (kmax-kmin);

pict=fopen(filename,"wb");
fprintf(pict,"P6\n");
fprintf(pict,"%d %d\n",ixsize,iysize);
fprintf(pict,"%d\n",255);

for (j=0;j<iysize;j++)
  {
  for (i=0;i<ixsize;i++)
    { 
     l=(int)((bild[i][j]-kmin)*d);
    fwrite(&r[l],sizeof(byte),1,pict);
    fwrite(&g[l],sizeof(byte),1,pict);
    fwrite(&b[l],sizeof(byte),1,pict);
    }
  }

fclose(pict);  


 printf("%g %g",julx,july);
 return(0);
}

