/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <math.h>
#include "constructs.h"
#define byte unsigned char

int main(int argc, char *argv[]);
int main(int argc, char *argv[])
{
FILE *pict,*colt;

int ixsize,iysize,i,j,l,iter,col;
double **bild;
double k,kmin,kmax;
double xsize,ysize,old_xsize,old_ysize;
double deltx,delty,xmax,xmin,ymax,ymin,d,dmin,xd,yd;
double imgs;

byte r[255],g[255],b[255];
int temp,max_col;
double bxmin,bxmax,bymin,bymax,bxd,byd;
double zre,zim,z0re,z0im,z2re,z2im,ar,br;
char test;

char filename[256];
char colors[256];

sscanf(argv[1],"%lf",&xmin);
sscanf(argv[2],"%lf",&xmax);
sscanf(argv[3],"%lf",&ymin);
sscanf(argv[4],"%lf",&ymax);
sscanf(argv[5],"%lf",&bxmin);
sscanf(argv[6],"%lf",&bxmax);
sscanf(argv[7],"%lf",&bymin);
sscanf(argv[8],"%lf",&bymax);
sscanf(argv[9],"%lf",&old_xsize);
sscanf(argv[10],"%lf",&old_ysize);
sscanf(argv[11],"%d",&iter);
sscanf(argv[12],"%lf",&imgs);
sprintf(colors,"%s",argv[13]);
sprintf(filename,"%s",argv[14]);

xd=xmax-xmin;
yd=ymax-ymin;

bxd=bxmax-bxmin;
byd=bymax-bymin;

if (bxd>byd) {
   xsize= imgs;
   ysize=imgs*byd/bxd; 
} else {
   ysize=imgs;
   xsize=imgs*bxd/byd; 
}
ixsize=(int) xsize;
iysize=(int) ysize;

xmax=xmin+xd*bxmax/old_xsize;
xmin=xmin+xd*bxmin/old_xsize;
ymax=ymin+yd*(old_ysize-bymin)/old_ysize;
ymin=ymin+yd*(old_ysize-bymax)/old_ysize;

bild=dmatrix(0,xsize,0,ysize);

deltx=(xmax-xmin)/xsize;
delty=(ymax-ymin)/ysize;

colt=fopen(colors,"r");

l=0;
while ((test=fgetc(colt))!=EOF && l<255)
 {
 ungetc(test,colt);
 fscanf(colt,"%d",&temp);
 r[l]=(unsigned char) temp;
 fscanf(colt,"%d",&temp);
 g[l]=(unsigned char) temp;
 fscanf(colt,"%d",&temp);
 b[l]=(unsigned char) temp;
 l++;
 }
max_col=l-2;

kmax=-1;
kmin=iter;

for (i=0;i<ixsize;i++)
  {
  zre=xmin+(double)i*deltx;
  
  for (j=0;j<iysize;j++)
    {
    zim=ymin+(double)j*delty;
/* Hier beginnt die Iteration */
    ar=zre*zre;
    br=zim*zim;
    z0re=zre;
    z0im=zim;
    k=0;
    for (l=0;l<iter;l++)
      {
      z2re=ar-br+zre;
      z2im=2.*z0re*z0im+zim;

      ar=z2re*z2re;
      br=z2im*z2im;
      if ((ar+br)>4.)
       {
       k=l;
       break;
       }
      z0re=z2re;
      z0im=z2im;
      }
/* Hier endet dir Iteration */
    k=log((double) (k+1));
    
    bild[i][iysize-j-1]=k;  
    kmax=DMAX(k,kmax);
    kmin=DMIN(kmin,k);
    }
  } 

d=(double) max_col/ (kmax-kmin);

pict=fopen(filename,"wb");

fprintf(pict,"P6 ");
fprintf(pict,"%d %d ",ixsize,iysize);
fprintf(pict,"%d ",255);

for (j=0;j<iysize;j++)
  {
  for (i=0;i<ixsize;i++)
    { 
    l=(int) ((bild[i][j]-kmin)*d);
    fwrite(&r[l],sizeof(byte),1,pict);
    fwrite(&g[l],sizeof(byte),1,pict);
    fwrite(&b[l],sizeof(byte),1,pict);
    }
  }

fclose(pict);  

 printf("%18.15g %18.15g %18.15g %18.15g %g %g", xmin,xmax,ymin,ymax,xsize,ysize);
 return(0);
}


