/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include <math.h>
typedef struct { double re; double im; } complex;

complex mult(complex a, complex b)
{
complex c;

c.re=a.re*b.re-a.im*b.im;
c.im=a.im*b.re+a.re*b.im;

return(c);
}
complex div(complex a, complex b)
{
complex c;
double nenner;

nenner=b.re*b.re+b.im*b.im;

c.re=(a.re*b.re+a.im*b.im)/nenner;
c.im=(a.im*b.re-a.re*b.im)/nenner;

return(c);
}
complex sca_mult(double b,complex a)
{
complex c;

c.re=a.re*b;
c.im=a.im*b;

return(c);
}

complex add(complex a, complex b)
{
complex c;

c.re=a.re+b.re;
c.im=a.im+b.im;

return(c);
}

complex sub(complex a, complex b)
{
complex c;

c.re=a.re-b.re;
c.im=a.im-b.im;

return(c);
}

double dist(complex a,complex b)
{
return((a.re-b.re)*(a.re-b.re)+(a.im-b.im)*(a.im-b.im));
}

