% Interface to MATHTOOLS slope
% Analytical 2D stability analysis
% and numeric solution
% Author C. Kohlmeier
% last change 110419

clear all;
beep off;
clc;

% Parameter to be used
syms a b c d e f g  x y f1 f2
a_=0;b_=0;c_=0;d_=0;e_=0;f_=0;g_=0;


% Reading data from tgf file
fid = fopen('tempin.tgf');
f1=fgetl(fid);
f2=fgetl(fid);
minx=fgetl(fid);
miny=fgetl(fid);
maxx=fgetl(fid);
maxy=fgetl(fid);
maxsteps=fgetl(fid);
endtime=fgetl(fid);
a_=fgetl(fid);
b_=fgetl(fid);
c_=fgetl(fid);
d_=fgetl(fid);
e_=fgetl(fid);
fclose(fid);

% Jacobian matrix
a=a_;b=b_;c=c_;d=d_;e=e_;

f1=subs(f1)
f2=subs(f2)

J = jacobian([f1;f2], [x,y]);

% Non trival steady state

fix=solve(f1,f2,'x','y');

for i=1:size(fix.x)
if fix.x(i) ~=0 && fix.y(i)~=0 
  xstar=fix.x(i);
  ystar=fix.y(i);
end
end

% Linearization
x=xstar;
y=ystar;
Jstar=single(subs(J));


% Writing linear model

fid = fopen('tempout.tgf', 'wt');
fprintf(fid, '%s\n', 'a*x+b*y');
fprintf(fid, '%s\n', 'c*x+d*y');
fprintf(fid, '%f\n',-abs(str2num(maxx)));
fprintf(fid, '%f\n',-abs(str2num(maxy)));
fprintf(fid, '%f\n',abs(str2num(maxx)));
fprintf(fid, '%f\n',abs(str2num(maxy)));
fprintf(fid, '%f\n',str2num(maxsteps));
fprintf(fid, '%f\n',str2num(endtime));
fprintf(fid, '%f\n',Jstar(1,1));
fprintf(fid, '%f\n',Jstar(1,2));
fprintf(fid, '%f\n',Jstar(2,1));
fprintf(fid, '%f\n',Jstar(2,2));
fprintf(fid, '%s\n','');

fclose(fid);

exit;