/* TigerGraphics Math and Fractal Tool 1.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg */
#include <stdio.h>
#include <string.h>
#include <math.h>


int main(int argc, char *argv[]);

int main(int argc, char *argv[])
{
 int nmax,k,j,nanz,l;
 double lamda,left,seps,delt;
 double s,t;
 double anf;
 double end;
 double sum;
 double outdelt,sample;
 double mini,maxi;
 double eps;

  sscanf(argv[1],"%d",&nmax);
  sscanf(argv[2],"%lf",&lamda);
  sscanf(argv[3],"%lf",&s);
  sscanf(argv[4],"%lf",&anf);
  sscanf(argv[5],"%lf",&end);
  sscanf(argv[6],"%lf",&sample);
  sscanf(argv[7],"%d",&nanz);

  eps=(end-anf)/nanz;

  outdelt=eps/sample;
  seps=0.0;

  for (j=0;j<nanz;j++)
  {
   left=anf+(double) j*eps;

    mini=10000.0;
    maxi=-10000.0;

    for (l=0;l<sample;l++)
    {
      sum=0.0;
      t=left+(double) l*outdelt;
      for (k=1;k<=nmax;k++)
      {
        sum+=pow(lamda,(s-2.0)*(double)k)*sin(pow(lamda,(double)k)*t);
      }
      mini=mini<sum?mini:sum;
      maxi=maxi>sum?maxi:sum;
    }
    seps=seps+(maxi-mini)/eps;

   }
   seps/=(end-anf);
   delt=-log(seps)/log(eps);

   printf("%g\n",delt);
 return(0);
}


