# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc automat_init { } {

global model nstates newworld ncolors blue color coltab nmax DOS

  set coltab default; makecolor; clear

  switch $model {
     Wolfram {set nstates 1
           set ncolors 1
           set newworld 1
       }
     Life {set nstates 1
           set ncolors 1
           set newworld 1
       }
     Disease {set nstates 3
              set ncolors 3
              set newworld 1
       }
     PerBak04 {set nstates 4
             set ncolors 6
             set newworld 0
       }
     PerBak08 {set nstates 8
               set ncolors 10
               set newworld 0
       }
     PerBug04 {set nstates 4
               set ncolors 5
               set newworld 0
       }

     PerBug14 {set nstates 4
              set ncolors 6
              set newworld 0
       }

     CircularRoom6 {set nstates 5; # 0..5
                   set ncolors 5
                   set newworld 1
       }
       
      CircularRoomN {set nstates 11; #muss auf 50x50 laufen
                   set ncolors 11
                   set newworld 1
       }
             
       
     Beetle {set nstates 24
                   set ncolors 24
                   set newworld 1
       }


     Diff {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab black&white; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"

       }

     Adv1DOK {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab black&white; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"
       }

     Adv1D {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab black&white; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"
       }

     Adv2D {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab black&white; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"
       }

     Leopard2 {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab leo; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"
       }
     Leopard6 {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab leo; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"
       }

     Fast-Leopard {set nstates 255
                   set ncolors 255
                   set newworld 1
                   set coltab leo; makecolor
                   bind .ov.plot <1> "itemMark .ov.plot %x %y; cellclick %x %y 255"
       }

  }

#alten colorbar loeschen
  .ov.right.col delete bar

  set breite [.ov.right.col cget -width]

#Colorbar erzeugen
set wid [expr int($breite/$nstates)+1]

  if {$wid>50} {set wid 50}
  for {set i 0} {$i<= $nstates} {incr i} {
    .ov.right.col create rect [expr $i*$wid] 0 [expr ($i+1)*$wid] 30 -fill $color($i) -outline $color($i) -tag colrect($i) -tag bar
    if {$nstates<25 } {
       .ov.right.col create text [expr int(($i+0.5)*$wid)] 15 -text $i -anchor c -fill white -tag colnum($i) -tag bar
    }
  }

}
