# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# proc leopard_c
##################################################
proc leopard_c {generation Db} {
global lifefeld nmax newworld savefeld baumfeld
global exec_dir rlist ncolors
global nstates init
if ![info exist init] {set init 1}

# lifefeld Konzentration
# savefeld retten des Aktivators
# baumfeld Inhibitor
# Diffusion rate inhibitor (diffusion rate activator=Db/qa)
set ma  1.0;              #% Zerfallsrate des Aktivators (ra<rb)
set mb  1.0;              #% Zerfallsrate des Inhibitors
set epsa  0.01;       #% Grundproduktion von A
set epsb  0.01;       #% Grundproduktion von B
set qa 8.0;             #% Diffusion von A langsamer um Faktor qAH


set clist "$nmax $newworld $Db $ma $mb $epsa $epsb $qa"

# Retten der alten Werte
# Beim ersten mal von nstates runterskalieren
if {$init==1} {
  set scale [expr 1.0*$nstates]
  set init 0
} else {
  set scale 1.0
}


for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      lappend clist [format %.6f [expr $savefeld($i,$j)/$scale]]
   }
}
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
      lappend clist $baumfeld($i,$j)
   }
}

# Aufruf des C-Programms fuer eine Generation

set rlist [eval exec $exec_dir/leopard $clist]
#Neue Werte des Aktivators
set ind 0
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {

     set wert [lindex $rlist $ind]
     set savefeld($i,$j) $wert
     # Farbe bestimmen
     set col [expr int($wert*$nstates)]
     if {$col > $ncolors} {set col $ncolors}
     set lifefeld($i,$j) $col
     incr ind
}
}

#Neue Werte des Inhibitors
for {set i 0} { $i <= $nmax} {incr i} {
   for {set j 0} { $j <= $nmax} {incr j} {
     set baumfeld($i,$j) [lindex $rlist $ind]
     incr ind
     }
   }


}

