# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
# proc leopard_c
##################################################
proc leopard_f {generation Db} {
global lifefeld nmax newworld savefeld baumfeld
global exec_dir install_dir storedir rlist ncolors
global nstates init can
global done ready leopid

if ![info exist init] {set init 1}

if { [info exist leopid] && $generation<=1 } {
        set init 1
        set command "exec kill -KILL $leopid"
        catch $command result
        after 100
}

# lifefeld Konzentration
# savefeld retten des Aktivators
# baumfeld Inhibitor
# Diffusion rate inhibitor (diffusion rate activator=Db/qa)

if {$init==0} {
  after 10
  set command "exec kill -CONT $leopid"
  catch $command result
} else {	
        set init 0
        set ma  1.0;              #% Zerfallsrate des Aktivators (ra<rb)
        set mb  1.0;              #% Zerfallsrate des Inhibitors
        set epsa  0.01;       #% Grundproduktion von A
        set epsb  0.01;       #% Grundproduktion von B
        set qa 8.0;             #% Diffusion von A langsamer um Faktor qAH

        set clist "$nmax $newworld $Db $ma $mb $epsa $epsb $qa"
        lappend clist $install_dir/colors/leo.dat 
        lappend clist $storedir/temp/leo.ppm
# von nstates runterskalieren
        set scale [expr 1.0*$nstates]
        for {set i 0} { $i <= $nmax} {incr i} {
          for {set j 0} { $j <= $nmax} {incr j} {
             lappend clist [expr $savefeld($i,$j)/$scale]
          }
        }
        for {set i 0} { $i <= $nmax} {incr i} {
           for {set j 0} { $j <= $nmax} {incr j} {
              lappend clist $baumfeld($i,$j)
           }
        }
# Start des C-Programms 
        set command "$exec_dir/fast-leopard $clist"
        set pipe [open "|$command"]
        fileevent $pipe readable [list picture_update $pipe]
        vwait ready
}

}

proc picture_update {pipe} {
        global exec_dir install_dir storedir rlist ncolors
        global nstates init can nmax
        global done ready leopid
        
        gets $pipe leopid
        set ready 0
        if {[eof $pipe ]} {
           catch {close $pipe}
           set done 1
           set init 1
           return
        }
#        after 10
        set t [image create photo -file $storedir/temp/leo.ppm] 
        image create photo leo
#        $t copy leo
#        leo blank
        leo copy $t -shrink -zoom [expr $can/($nmax+1)] 

        set item [.ov.plot create image 1 1 -image leo -anchor nw]
        image delete $t
        
        set ready 1
}

