# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc bifuControl {} {
global can ovc
global boldFontN
global name

set ovc .ov.right.control

frame $ovc
pack $ovc


#toplevel $ovc
#wm title $ovc { Control panel }
#wm geometry $ovc "250x300+610+300"
#wm geometry $ovc "+660+300"

global maxsteps maxstep minpar maxpar minlambda maxlambda
global bifu_par
global which
global lamda
global offsetx offsety showcoor showbifu
global dt functiony

set functiony y+a*y*(1-y)

set dt 1
set showcoor 1
set showbifu 1
set offsetx 0
set offsety 0
set lamda 0
set which bifu
set nmax 0
set stop 0
set minlambda 1
set maxlambda 3
set minpar 1
set maxpar 4
set maxstep 10000
set maxsteps 300
set tick 1
set big 1
set bifu_x 1

init_bifu

frame $ovc.left
pack $ovc.left

bind .ov.plot <1> "itemMark .ov.plot %x %y; set bifu_par %x;parabel;init_parabel;raisewindows;wm iconify .ov"
bind .ov.plot <Motion> "set xc %x; set yc %y;setcoo;raisewindows"

# Initializing of sliders
#------------------------


frame $ovc.left.funcx
pack $ovc.left.funcx -fill x

label $ovc.left.funcx.flx -text "y_(n+1)=" -font $boldFontN
pack $ovc.left.funcx.flx -side left

entry $ovc.left.funcx.fex -width 30 -relief sunken \
           -textvariable functiony -font $boldFontN
pack $ovc.left.funcx.fex -side left -pady 10



scale $ovc.left.par1 -from $minpar -to $maxpar\
      -variable minlambda \
      -length 200 \
      -orient horizontal -label "Select minimum parameter a"       \
      -tickinterval 1 -showvalue true -resolution 0.01 \
      -bigincrement 1 -font $boldFontN
pack $ovc.left.par1 -fill x


scale $ovc.left.par2 -from $minpar -to $maxpar\
      -variable maxlambda \
      -length 200 \
      -orient horizontal -label "Select maximum parameter a"       \
      -tickinterval 1 -showvalue true -resolution 0.01 \
      -bigincrement 1 -font $boldFontN
pack $ovc.left.par2 -fill x

scale $ovc.left.num -from 0 -to $maxstep\
      -variable maxsteps \
      -length 200 \
      -orient horizontal -label "Select iteration steps"       \
      -tickinterval [expr $maxstep/4] -showvalue true -resolution 1 \
      -bigincrement [expr $maxstep/100] -font $boldFontN

pack $ovc.left.num -fill x


frame $ovc.calc
pack $ovc.calc

#set steps "1 0.1 0.01 0.001"
#label $ovc.calc.txt -text "Time step" -font $boldFontN
#pack $ovc.calc.txt -side left

#foreach step $steps {
# radiobutton $ovc.calc.$step -text $step -value $step -variable dt -font $boldFontN
# pack $ovc.calc.step -side left
#}

button $ovc.calc.fix -text "Calculate"  -command {calc_par 1} -font $boldFontN
pack $ovc.calc.fix -side left

# button $ovc.calc.init -text "Init"  -command {calc_par 0} -font $boldFontN
# pack $ovc.calc.init -side left



#button $ovc.calc.dgl -text "Calculate as DGL"  -command {calc_par 0.1} -font $boldFontN
#pack $ovc.calc.dgl

frame $ovc.right
pack $ovc.right

frame $ovc.right.misc
pack $ovc.right.misc -side bottom -pady 10

checkbutton $ovc.right.misc.bifu -text {Show Bifu.}  -font $boldFontN \
       -variable showbifu
pack $ovc.right.misc.bifu -fill x -side left

checkbutton $ovc.right.misc.tp -text {Time Plot}  -font $boldFontN \
       -variable timeplot
pack $ovc.right.misc.tp -fill x -side left

checkbutton $ovc.right.misc.coor -text {Show Coor.}  -font $boldFontN \
       -variable showcoor
pack $ovc.right.misc.coor -fill x -side left


button $ovc.right.misc.ps -text {PS print} \
       -command {printout} -font $boldFontN 
pack $ovc.right.misc.ps -fill x
  calc_par 0

}


