# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc bifu_timeplot {} {
global can
global txmin txdelt tpxmin tpxdelt
global tymin tydelt tpymin tpydelt
global boldFontN
global parsteps

if ![winfo exist .timebifu] {
	
    toplevel .timebifu
    wm title .timebifu {Time Plot}
    wm geometry .timebifu "+[expr $can]+0"
#    wm group .timebifu .ov
#    wm transient .timebifu .ov
	wm protocol .timebifu WM_DELETE_WINDOW {.timebifu.exit invoke}
    set tcanx $can
    set tcany 200

    canvas .timebifu.plot  -bg white -width $tcanx -height $tcany
    pack .timebifu.plot

        
    button  .timebifu.save -text {Print} -command {printout .timebifu.plot}
    pack    .timebifu.save -side left 

    button  .timebifu.exit -text {Close} -command {destroy .timebifu}
    pack    .timebifu.exit
    
    
    set tpxmin 0
    set tpxdelt $tcanx
    set tpymin $tcany
    set tpydelt -$tcany

    set txmin 0
    set txmax $parsteps 
    set txdelt [expr $txmax-$txmin] 

    set tymin 0
    set tymax 2
    set tydelt [expr $tymax -$tymin] 

    #Achsen
            
    set item [.timebifu.plot create text 5 5 -text $tymax -fill black \
                -font $boldFontN -anchor nw]
            
    set item [.timebifu.plot create text 5 $tcany -text $txmin,$tymin -fill black \
                -font $boldFontN -anchor sw]

    set item [.timebifu.plot create text $tcanx $tcany -text $txmax -fill black \
                -font $boldFontN -anchor se]

} else {

    #raise .parabel
    #raise .timebifu
}
}

proc tnnx {x} {
global txmin txdelt tpxmin tpxdelt
set retval [expr {$tpxmin+($x-$txmin)*$tpxdelt/$txdelt}]
#puts "x=$xplotx=$retval"
return $retval
}

proc tnny {y} {
global tymin tydelt tpymin tpydelt
set retval [expr {$tpymin+($y-$tymin)*$tpydelt/$tydelt}]
#puts "y=$y ploty=$retval"
return $retval
}


