# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_parabel {{wait 0}} {
global pcan next a
global plotFontS symbFont
global julx july
global parsteps cut
global commandy
global timeplot

.parabel.plot delete lines
.parabel.plot delete dot

set x [bpnnx $julx]
set y $x
set rad [expr 1.5 *1.41]
set radd [expr 2 *1.41]
set item [.parabel.plot create text $julx [expr $pcan-10] -text [format "%4.2f" $x] \
             -font $plotFontS -anchor w -tag lines ]
	     	     
for {set i 1} {$i < $parsteps } {incr i} {

   set newx [expr $commandy]
   if {$i==1} {set y 0; 
	   if {$timeplot==1} {destroy .timebifu; bifu_timeplot} else {destroy .timebifu}
   }   
   if {$cut==0 || $i >[expr $parsteps/2]} {
     .parabel.plot create line [bnnx $x] [bnny $y] [bnnx $x] [bnny $newx] -tag lines
     .parabel.plot delete dot
     .parabel.plot create oval [expr [bnnx $x]-$radd] [expr [bnny $newx]+$radd] [expr [bnnx $x]+$radd] [expr [bnny $newx]-$radd] -fill red -outline red -tag dot
     
     if {$wait==1} { tkwait variable next;if {$timeplot==1} {bifu_timeplot}}

        .parabel.plot create line [bnnx $x] [bnny $newx] [bnnx $newx] [bnny $newx] -tag lines
     
        if {$timeplot==1} {
        
        #.timebifu.plot create line [tnnx $x] [tnny $newx] [tnnx $newx] [tnny $newx] -tag lines
        #.timebifu.plot create text  [tnnx $i] [tnny $newx] -text "*" -anchor center -font symbFont
        set xc [tnnx $i] 
        set yc [tnny $newx] 
        if {$i>0} {        
			.timebifu.plot create line [tnnx [expr $i-1]] [tnny $x] $xc $yc -tag lines -fill #cccccc
        }
        .timebifu.plot create oval  [expr $xc - $rad] [expr $yc + $rad] [expr $xc + $rad] [expr $yc - $rad] -outline red -fill red
        }     
   }
set x $newx
set y $newx 
}     
}
