# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc it_sier {number x1 y1 x2 y2 x3 y3} {
global nmax mode
global w3h
global help

set c .ov.plot

if {$number >= $nmax} { 

    set item [eval {$c create poly} [nnx $x1] [nny $y1] \
                                    [nnx $x2] [nny $y2] [nnx $x3] [nny $y3]]
    $c addtag curve withtag $item
    update

} else {

   incr number

   set delt [expr $x2-$x1]
   set xh [expr $x1+0.5*($x2-$x1)]
   set yh [expr $y1+$delt*$w3h]
   
   it_sier $number $x1 $y1 $xh $yh $x2 $y3
   it_sier $number $xh $yh $x2 $y2 [expr $xh+$delt] $yh  
   it_sier $number $x2 $y3 [expr $xh+$delt] $yh $x3 $y3
}
}

proc calc_sier {} {
global xmin xdelt pxmin pxdelt
global ymin ydelt pymin pydelt
global nmax mode
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global w3h
global can

set w3h [expr sqrt(3)/2.0]

set x1 0
set y1 0
set x2 0.5
set y2 $w3h
set x3 1
set y3 0

set xmin -0.5
set xdelt 2.0
set pxmin 0
set pxdelt $can
set pymin $can
set pydelt -$can
set ymin -0.5
set ydelt 2.0

erase .ov.plot all
     it_sier 0 $x1 $y1 $x2 $y2 $x3 $y3

set item [.ov.plot create text [expr $can/2] 20 -text "Sierpinski's Fractal" \
             -font $boldFontN -anchor c]

set item [.ov.plot create text [expr $can/2] 40 -text "$nmax iterations" \
             -font $plotFontS -anchor c]

}


