# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

proc calc_abb {k} {
global ox oy
global ix iy
global a b c d e f det con condensation
global xmin xmax ymin ymax
global which



set nenner [expr $ox(2) *$oy(3) - $ox(1) *$oy(3) + $ox(1) *$oy(2) \
               + $ox(3) *$oy(1) - $ox(3) *$oy(2) - $ox(2) *$oy(1)]


set a($k) [expr -($oy(1)*$ix(2) - $oy(1)*$ix(3) + $oy(2)*$ix(3) - $ix(2)*$oy(3) + $ix(1)*$oy(3) - $ix(1)*$oy(2))/$nenner]

set b($k) [expr ($ox(1)*$ix(2) + $ox(2)*$ix(3) - $ox(3)*$ix(2) - $ox(2)*$ix(1) - $ox(1)*$ix(3) + $ox(3)*$ix(1))/$nenner]

set c($k) [expr -(-$oy(3)*$iy(2) + $oy(1)*$iy(2) - $oy(1)*$iy(3) + $iy(1)*$oy(3) - $iy(1)*$oy(2) + $iy(3)*$oy(2))/$nenner]

set d($k) [expr ($ox(3)*$iy(1) + $ox(1)*$iy(2) - $ox(2)*$iy(1) - $ox(1)*$iy(3) - $ox(3)*$iy(2) + $ox(2)*$iy(3))/$nenner]

set e($k) [expr (-$oy(1)*$ox(2)*$ix(3) + $ix(1)*$ox(2)*$oy(3) + $oy(2)*$ox(1)*$ix(3) - $oy(2)*$ox(3)*$ix(1) - $ix(2)*$ox(1)*$oy(3) + $oy(1)*$ox(3)*$ix(2))/$nenner]

set f($k) [expr (-$oy(3)*$ox(1)*$iy(2) + $iy(3)*$ox(1)*$oy(2) + $oy(1)*$ox(3)*$iy(2) - $oy(1)*$ox(2)*$iy(3) + $oy(3)*$ox(2)*$iy(1) - $iy(1)*$ox(3)*$oy(2))/$nenner]

set xmin -0.5
set xmax 1.5
set ymin -0.5
set ymax 1.5
set which "Tiger Graphics Special"

if {$k==1} {
  textdel 0 end
  if {$condensation==1} {textinfo "Last map is condensation"}
}

textinfo "a$k=$a($k) b$k=$b($k) c$k=$c($k) d$k=$d($k) e$k=$e($k) f$k=$f($k)"

set det(1) 0
set det(2) 0
set det(3) 0
set det(4) 0

# Wenn condensation ==1 wird die letzte Abb. als condensation ausgefuehrt

if {$condensation==0} {
switch $k {
1 {set det(1) 1.0}
2 {set det(1) 0.5; set det(2) 0.5}
3 {set det(1) 0.3333; set det(2) 0.3333; set det(3) 0.3333}
4 {set det(1) 0.25; set det(2) 0.25; set det(3) 0.25; set det(4) 0.25}
}
} else {

set con(a) $a($k);set con(b) $b($k);set con(c) $c($k)
set con(d) $d($k);set con(e) $e($k);set con(f) $f($k)

switch $k {
1 {set det(1) 0.0}
2 {set det(1) 0.5; set det(2) 0.0}
3 {set det(1) 0.3333; set det(2) 0.3333; set det(3) 0.0}
4 {set det(1) 0.25; set det(2) 0.25; set det(3) 0.25; set det(4) 0.0}
}
}

parswap_rev $k
}

