# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_copy {} {
global xmin xmax ymin ymax xdelt ydelt
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global iter
global a b c d e f det 
global which
global xdelt pxmin pxdelt
global ydelt pymin pydelt
global polygon pp poly
global cls
global count len indanf indend
global x1 y1 x2 y2

set x1 0
set x2 1

set y1 0
set y2 1


if ![info exists polygon] {
  set polygon {$x1 $y1 $x1 $y2 $x2 $y2 $x2 $y1}
  set poly {[nnx $x1] [nny $y1] [nnx $x1] [nny $y2] [nnx $x2] [nny $y2] [nnx $x2] [nny $y1] } 
}


erase .ov.plot counter
if {$cls==1} {erase .ov.plot all}

if {$count ==0} {set item [eval {.ov.plot create poly} $poly -fill black]}


.ov.plot create text 300 20 -text $which    -font $boldFontN -anchor c

#erase .ov.plot counter 
.ov.plot create text 300 40 -text "[expr $count] steps"  -font $plotFontS -anchor c -tag counter

#calc_det

set len [llength $polygon]

if {$count==0} { 
     if [info exist pp] {unset pp}
     set pp($count) $polygon
     set indanf 0
     set indend 0
  }

if {$count >0} {calc_polyimg}

incr count

}


proc calc_polyimg {} {
global pp
global a b c d e f det
global pimg
global count len coltab
global indanf indend count bunt
global x1 y1 x2 y2

scan [expr $indend] %d ind

for {set j $indanf} {$j<=$indend} {incr j} {

  for {set nn 1} {$nn<=4} {incr nn} {
    if {$det($nn) > 0} {
      incr ind 

     if [info exist poly] {unset poly}
     for {set i 0} {$i<$len} {set i [expr $i+2]} {
        set xa [lindex $pp($j) $i]
        set ya [lindex $pp($j) [expr $i+1]]
 
        set x [expr $a($nn)*$xa+$b($nn)*$ya+$e($nn)]
        set y [expr $c($nn)*$xa+$d($nn)*$ya+$f($nn)]
        lappend pp($ind) $x $y
        lappend poly [nnx $x] [nny $y]
      }
      if {$count < 8 && $bunt==1} {
         set col [lindex $coltab [expr $count]]
      } else {set col black}
      set item [eval {.ov.plot create poly} $poly -fill $col]

   }
  }
}
 
set indanf [expr $indend+1]
set indend $ind




}




