# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc ifsControl {} {
global can ovc
global boldFontN
global tclsrc_dir
global name

set ovc .ov.right.control

frame $ovc
pack $ovc

puts $can

#toplevel $ovc
#wm title $ovc { Control panel }
#wm geometry $ovc "250x300+630+300"
#wm geometry $ovc "+630+260"

set c .ov.plot


global areaX1 areaY1 areaX2 areaY2
global icount ocount
global coltab
global colind copy cls count rx bunt polygon poly
global condensation ox
global can

set coltab {black red cyan gold magenta purple limegreen green yellow lightblue}
set colind 1
set areaX1 0
set areaY1 0
set areaX2 0
set areaY2 0
set copy 0
set every 1
set cls 1
set count 0
set bunt 0
set condensation 0

bind $c <1> "itemMark .ov.plot %x %y; get_image %x %y"
bind $c <2> "itemMark .ov.plot %x %y; get_poly %x %y"

global which
global iter

set which fern
set iter 1000

frame $ovc.left
pack $ovc.left

# Initializing of sliders
#------------------------

menubutton $ovc.left.which -text Fractal -menu $ovc.left.which.menu -font $boldFontN -relief raised
pack $ovc.left.which
set m [menu $ovc.left.which.menu -tearoff 0]

set labels {fern tree dragon pythagoras sierpinski chess maple}
set name(fern) Fern
set name(tree) Tree
set name(dragon) "Highway Dragon"
set name(pythagoras) "Pythagoras' Tree"
set name(sierpinski) "Sierpinski's Triangle"
set name(chess) "Chess (with condensation)"
set name(square) "Square"
set name(maple) "Maple Leaf"


foreach lab $labels {
  $m add radio -label $name($lab) -variable which -value $lab -font $boldFontN \
               -command { ReadCom $tclsrc_dir/ifs/par/$which.ifs
                          parswap
			  get_screen
			  setname $ovc.left.which $name($which)
			}
}

$m invoke 0

scale $ovc.left.xmin -from 0 -to 50000\
      -variable iter \
      -length 200 \
      -orient horizontal -label "Number of points" \
      -tickinterval 50000 -showvalue true -resolution 100 \
      -bigincrement 1000 -font $boldFontN
pack $ovc.left.xmin -pady 20



frame $ovc.right
pack $ovc.right -pady 10

frame $ovc.right.misc
pack $ovc.right.misc -side left -padx 20

button $ovc.right.misc.calc -text {Calculate} \
       -command { if {$copy==1} {calc_copy} else {calc_ifs}} -font $boldFontN
pack $ovc.right.misc.calc -fill x -pady 5
 


button $ovc.right.misc.poly -text {Reset}  -font $boldFontN \
       -command {
                 if [info exists polygon] {unset polygon}
                 if [info exists poly] {unset poly}
                 if [info exists rx] {unset rx}
                 set count 0
                } 
pack $ovc.right.misc.poly -fill x -pady 5
 
 
button $ovc.right.misc.clear -text {Clear screen}  -font $boldFontN \
       -command {erase .ov.plot all}
pack $ovc.right.misc.clear -fill x  -pady 5


button $ovc.right.misc.ps -text {PS print}  -font $boldFontN \
       -command {printout}
pack $ovc.right.misc.ps -fill x -pady 5


frame $ovc.right.copy
pack $ovc.right.copy

checkbutton $ovc.right.copy.every -text {Show steps} \
       -variable every -font $boldFontN  -anchor w
pack $ovc.right.copy.every -fill x

checkbutton $ovc.right.copy.copy -text {Copy machine} \
       -variable copy -font $boldFontN -anchor w
pack $ovc.right.copy.copy -fill x

checkbutton $ovc.right.copy.cls -text {Clear between} \
       -variable cls -font $boldFontN  -anchor w
pack $ovc.right.copy.cls -fill x

checkbutton $ovc.right.copy.bunt -text {Color} \
       -variable bunt  -font $boldFontN  -anchor w
pack $ovc.right.copy.bunt -fill x

frame $ovc.right.ifs
pack $ovc.right.ifs -pady 10

button $ovc.right.ifs.new -text {Set IFS}  -font $boldFontN \
       -command {                 
                          if [info exists polygon] {unset polygon}
                          if [info exists poly] {unset poly}
                          if [info exists rx] {unset rx}
                          set count 0
                          set icount 1
                          set colind 1
                          erase .ov.plot all
                          set ocount 1
                          get_orig 100 100
                          get_orig 100 [expr $can -100]
                          get_orig [expr $can -100] [expr $can -100]
              }
pack $ovc.right.ifs.new -fill x
 
button $ovc.right.ifs.set -text {Set parameter} \
       -command {setifs} -font $boldFontN
pack $ovc.right.ifs.set -fill x

checkbutton $ovc.right.ifs.con -text {Condensation} \
       -variable condensation -font $boldFontN -anchor w
pack $ovc.right.ifs.con -fill x



}


