# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg

# main set ifs
#####################

proc setifs {} {
global textFont boldFontN ovc can
global comlab comname
toplevel .com

wm title .com {Parameter Control}
wm geometry .com "+0+[expr $can-20]"

$ovc.right.ifs.set configure -state disabled

set modeflag 0

frame .com.file
pack .com.file  -anchor e

button .com.file.load -text {Load} -font $boldFontN \
       -command {LoadCom}
pack .com.file.load -side left

button .com.file.save -text {Save} -font $boldFontN \
       -command {SaveCom} 
pack .com.file.save -side left

button .com.file.clr -text {Clear} -font $boldFontN \
       -command {clearpar}
pack .com.file.clr -side left

button .com.file.ok -text {Apply} -font $boldFontN \
       -command {parswap} 
pack .com.file.ok -side left


button .com.file.close -text {Close} -font $boldFontN \
       -command {destroy .com; $ovc.right.ifs.set configure -state normal} 
pack .com.file.close -side left


frame .com.mode
pack .com.mode -anchor w

label .com.mode.label -text {  }
pack .com.mode.label -side left

set j 1
for {set i 1} {$i<=4} {incr i} {
  frame .com.e$i
  pack .com.e$i

  foreach item "a b c d e f w" {

    label .com.e$i.b$item$i -text $item$i -font $boldFontN
    pack .com.e$i.b$item$i -side left

    entry .com.e$i.e$item$i -width 10 -relief sunken \
           -textvariable comlab($j) -font $textFont
    pack .com.e$i.e$item$i -side left
    incr j
   }
}

    frame .com.e$i
    pack .com.e$i -pady 5
    label .com.e$i.xmin -text xmin -font $boldFontN
    pack .com.e$i.xmin -side left

    entry .com.e$i.exmin -width 6 -relief sunken \
           -textvariable comlab($j) -font $textFont
    pack .com.e$i.exmin -side left
    incr j

 

    label .com.e$i.xmax -text xmax -font $boldFontN
    pack .com.e$i.xmax -side left

    entry .com.e$i.exmax -width 6 -relief sunken \
           -textvariable comlab($j) -font $textFont
    pack .com.e$i.exmax -side left
    incr j

 

    label .com.e$i.ymin -text ymin -font $boldFontN
    pack .com.e$i.ymin -side left

    entry .com.e$i.eymin -width 6 -relief sunken \
           -textvariable comlab($j) -font $textFont
    pack .com.e$i.eymin -side left
    incr j

 

    label .com.e$i.ymax -text ymax -font $boldFontN
    pack .com.e$i.ymax -side left

    entry .com.e$i.eymax -width 6 -relief sunken \
           -textvariable comlab($j) -font $textFont
    pack .com.e$i.eymax -side left



parswap
}

# save ifs parameters
#####################

proc SaveCom {} {
global storedir
global comlab

set name [fileselect "Select Parameter file" ifs  $storedir save IFS.ifs]
if {$name !=""} {
set ff [open $name w 0755]
for {set i 1} {$i <= 32} {incr i} {
  puts $ff $comlab($i)
}
close $ff
}
}
# load ifs parameters
#####################

proc LoadCom {} {
global storedir

set comname [fileselect "Select Parameter file" ifs $storedir open]

if { [file exists $comname] == 0  || $comname =={}} {
   set comname $storedir/IFS.ifs
}
ReadCom $comname
}


# reading parameters
#####################

proc ReadCom {name} {
global comlab

set ff [open $name]
set i 1
foreach item [split [read $ff] &\n] {
  set comlab($i) $item
  incr i
}
close $ff
parswap
}


# clearing parameters
#####################

proc clearpar {} {
global comlab
for {set i 1} {$i<= 28} {incr i} {
  set comlab($i) 0.0
}
parswap
}


# swapping parameters
#####################

proc parswap {} {
global comlab
global a b c d e f det con
global xmin xmax ymin ymax
global condensation

set a(1) $comlab(1)
set b(1) $comlab(2)
set c(1) $comlab(3)
set d(1) $comlab(4)
set e(1) $comlab(5)
set f(1) $comlab(6)
set det(1) $comlab(7)

set a(2) $comlab(8)
set b(2) $comlab(9)
set c(2) $comlab(10)
set d(2) $comlab(11)
set e(2) $comlab(12)
set f(2) $comlab(13)
set det(2) $comlab(14)

set a(3) $comlab(15)
set b(3) $comlab(16)
set c(3) $comlab(17)
set d(3) $comlab(18)
set e(3) $comlab(19)
set f(3) $comlab(20)
set det(3) $comlab(21)

set a(4) $comlab(22)
set b(4) $comlab(23)
set c(4) $comlab(24)
set d(4) $comlab(25)
set e(4) $comlab(26)
set f(4) $comlab(27)
set det(4) $comlab(28)

set xmin $comlab(29)
set xmax $comlab(30)
set ymin $comlab(31)
set ymax $comlab(32)

if {$condensation==0} {
  set con(a) 0.0;set con(b) 0.0;set con(c) 0.0
  set con(d) 0.0;set con(e) 0.0;set con(f) 0.0
} else {
  set con(a) $a(4);set con(b) $b(4);set con(c) $c(4)
  set con(d) $d(4);set con(e) $e(4);set con(f) $f(4)
}

}

# swapping parameters
#####################

proc parswap_rev {k} {
global comlab
global a b c d e f det
global xmin xmax ymin ymax
global condensation

set comlab(1) $a(1)
set comlab(2) $b(1)
set comlab(3) $c(1)
set comlab(4) $d(1)
set comlab(5) $e(1)
set comlab(6) $f(1)
set comlab(7) $det(1)

set comlab(8) $a(2)
set comlab(9) $b(2)
set comlab(10) $c(2)
set comlab(11) $d(2)
set comlab(12) $e(2)
set comlab(13) $f(2)
set comlab(14) $det(2)

set comlab(15) $a(3)
set comlab(16) $b(3)
set comlab(17) $c(3)
set comlab(18) $d(3)
set comlab(19) $e(3)
set comlab(20) $f(3)
set comlab(21) $det(3)

set comlab(22) $a($k)
set comlab(23) $b($k)
set comlab(24) $c($k)
set comlab(25) $d($k)
set comlab(26) $e($k)
set comlab(27) $f($k)
set comlab(28) $det($k)

set comlab(29) $xmin
set comlab(30) $xmax
set comlab(31) $ymin
set comlab(32) $ymax

}

