# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_jset {} {
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global xmin xmax ymin ymax
global storedir exec_dir install_dir
global julx july
global iter
global which
global ulx uly lrx lry oldxsize oldysize
global can

set plotFont $plotFontN

if {$which=="mandel"} {

.ov.plot config -cursor watch
update

set julx [expr $julx-50]
set july [expr $july-50]

set jul [exec $exec_dir/julia $xmin $xmax $ymin $ymax $ulx $lrx $uly $lry $oldxsize $oldysize $julx $july $iter [expr $can - 100] $install_dir/colors/redtemp.dat $storedir/temp/julia.ppm]

set xj [lindex $jul 0]
set yj [lindex $jul 1]

if ![file exists $storedir/temp] {file mkdir $storedir/temp}

if ![winfo exist .ovjulia] {
 toplevel .ovjulia
 wm title .ovjulia {Julia Set}
 wm geometry .ovjulia "+20+0"
  
  canvas .ovjulia.plot  -bg white -width [expr $can - 50] -height [expr $can - 50]
  pack .ovjulia.plot
  
  frame .ovjulia.buttons
  pack .ovjulia.buttons
  
  button  .ovjulia.buttons.save -text {Save & Print}  -font $boldFontN \
          -command {savegif $storedir/temp/julia.gif; printout .ovjulia.plot}
  pack    .ovjulia.buttons.save -side left
  
  button  .ovjulia.buttons.exit -text {Close} -command {destroy .ovjulia} -font $boldFontN
  pack    .ovjulia.buttons.exit

} 

.ovjulia.plot delete photo

image create photo julia -gamma 1.0 -file $storedir/temp/julia.ppm

#image create photo julia1
#julia1 copy julia -zoom 1


set item [.ovjulia.plot create image 25 25 -image julia -anchor nw]
.ovjulia.plot addtag photo withtag $item

set item [.ovjulia.plot create text [expr $can/2] [expr $can - 60]  -anchor c  -font $plotFontS\
          -text "\[-2,-2\]x\[2,2\]   c=\[$xj,$yj\]"] 
.ovjulia.plot addtag photo withtag $item

update

}

.ov.plot config -cursor top_left_arrow
raisewindows
update
}

