# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc autoscale {} {

global toolflag
global textFont boldFontN ovc toolflag
global comlab comname
global minx miny maxx maxy mint maxt

global axmin axmax aymin aymax


if ![info exist aymin] {
   return
} else {
puts $aymin
 if {$aymin == inf} {return}

}

set zero 0.00001
puts "autoscale: $axmin $axmax $aymin $aymax"


if {[expr abs($axmax-$axmin)] <$zero} {
    set axmax [expr $axmin+$zero]
    set axmin [expr $axmin-$zero]
}
if {[expr abs($aymax-$aymin)] <$zero} {
    set aymax [expr $aymin+$zero] 
    set aymin [expr $aymin-$zero]
}

set minx [expr [nextint $axmin]-2]
set maxx [expr [nextint $axmax]+1]
set miny [expr [nextint $aymin]-2]
set maxy [expr [nextint $aymax]+1]

puts "autoscale: $minx $maxx $miny $maxy"

destroy .com
destroy $ovc
 switch $toolflag {
      "plot" {plotControl;$ovc.right.misc.tp invoke}
      "slope" {slopeControl;$ovc.left.er.calc invoke;$ovc.left.er.cawp invoke}
}
}


proc rd {x} {
if {$x <= 0} {return $x}

set expo [expr log10($x)]


set h [expr pow(10.0,floor($expo))]

set h2 [expr floor(1.0*$x/$h)]

if {$h2*$h != $x} {
  set y [expr ($h2+1)*$h]
} else {
  set y [expr $h2*$h]
}

return $y
}

