# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc xlineDown {w x y} {
global pxmin pxmax lastX lastY
   set item [$w create line $pxmin $y $pxmax $y -fill blue]
   $w addtag xline withtag $item
   set item [$w create text [expr $pxmin]  [expr $y-10]  -fill blue \
                -text [format "%4.2g" [invnny $y]] -anchor w]
   $w addtag xline withtag $item
   $w addtag xlinetext withtag $item

    set lastX [$w canvasx $x]
    set lastY [$w canvasy $y]
}

proc xlineMotion {w x y} {
    global lastX lastY
    set x [$w canvasx $x]
    set y [$w canvasy $y]

    $w move xline 0 [expr $y-$lastY]
    $w itemconfig xlinetext -text [format "%4.2g" [invnny $y]] -anchor w
    set lastX $x
    set lastY $y
}

proc xlineRelease {w} {
  $w delete xline
  $w dtag xline
}


proc ylineDown {w x y} {
global pymin pymax lastX lastY
   set item [$w create line $x $pymin $x $pymax -fill blue]
   $w addtag yline withtag $item

   set item [$w create text [expr $x+15] [expr $pymin]  -fill blue \
              -text [format "%4.2f" [invnnx $x]] -anchor s]
   $w addtag yline withtag $item
   $w addtag ylinetext withtag $item

    set lastX [$w canvasx $x]
    set lastY [$w canvasy $y]
}

proc ylineMotion {w x y} {
    global lastX lastY
    set x [$w canvasx $x]
    set y [$w canvasy $y]

    $w move yline [expr $x-$lastX] 0
    $w itemconfig ylinetext -text [format "%4.2f" [invnnx $x]] -anchor s
    set lastX $x
    set lastY $y
}

proc ylineRelease {w} {
  $w delete yline
  $w dtag yline
}



