# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc plotpara {} {
global can
global tmin tmax
global xmin xmax xdelt pxmin pxmax pxdelt
global ymin ymax ydelt pymin pymax pydelt
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global function command fname
global a b c d e
global axmin axmax aymin aymax

set axmin inf
set axmax -inf
set aymin inf
set aymax -inf

set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]

set_plot

set color(1) black
set color(2) red
set color(3) seagreen

set width 1

set yval 0
set yoff 20

axes

set command(1) [makecommand $function(1)]
set command(2) [makecommand $function(2)]

set t $tmin

set steps 1000
set dt [expr double($tmax-$tmin)/$steps]

set x [expr double($command(1))]
set y [expr double($command(2))]

for {set j 0} {$j<=$steps} {incr j} {
    set xa $x
    set ya $y

    set t [expr $tmin +$j*$dt]
    
    if {[catch { expr double($command(1)) } result]} {
    	textinfo "Fehler bei $x: $result"
    } else {
    	set xn $result
    }
    
    if {[catch { expr double($command(2)) } result]} {
    	textinfo "Fehler bei $x: $result"
    } else {
    	set y $result
    }

    set x $xn
    .ov.plot create line [nnx $xa] [nny $ya] [nnx $x] [nny $y]\
                       -tag richt -fill $color(1) -width $width
                       
set axmin [min $axmin $x]
set axmax [max $axmax $x]
set aymin [min $aymin $y]
set aymax [max $aymax $y]
                       
                       
}
   
   
   set yval [expr $yval+$yoff]
   .ov.plot create text 15 $yval -text "$fname(1) $function(1)"  -font $boldFontN -anchor w -tag title -fill $color(1)
   set yval [expr $yval+$yoff]
   .ov.plot create text 15 $yval -text "$fname(2) $function(2)"  -font $boldFontN -anchor w -tag title -fill $color(1)

.ov.plot create text 15 [expr $yval+$yoff] -text "a=$a b=$b c=$c d=$d e=$e"  -font $boldFontN -anchor w -tag title
.ov.plot create text 15 [expr $yval+2*$yoff] -text "($xmin,$xmax)x($ymin,$ymax)" -font $boldFontN -anchor w -tag title
.ov.plot create rect 10 10 200 [expr $yval+3*$yoff]  -tag title

}


