# TigerGraphics Math and Fractal Tool 1.2.2 Copyright (C) 2023, Cora Kohlmeier, Frank Hamberg
proc calc_slope {} {
global can ovc
global xmin xmax xdelt pxmin pxmax pxdelt
global ymin ymax ydelt pymin pymax pydelt
global maxsteps maxstep minlambda maxlambda
global plotFontN plotFontS plotFontT
global boldFontN boldFontS boldFontT
global functionx commandx functiony commandy
global maxsteps maxstep
global minx maxx miny maxy
global a b c d e
global t0 stop
global slopeplot

set stop 1
update
update idletasks

set a [formatpar $a]
set b [formatpar $b]
set c [formatpar $c]
set d [formatpar $d]
set e [formatpar $e]

set color black
set width 1

# set minx [lindex [Scale2Value $ovc.left.x] 0]
# set maxx [lindex [Scale2Value $ovc.left.x] 1]
# set miny [lindex [Scale2Value $ovc.left.y] 0]
# set maxy [lindex [Scale2Value $ovc.left.y] 1]

set xmin $minx
set xmax $maxx
set ymin $miny
set ymax $maxy

textinfo $xmax

set xdelt [expr $xmax -$xmin]
set ydelt [expr $ymax -$ymin]

set pxmin 0
set pxmax $can
set pxdelt $can
set pymin $can
set pymax 0
set pydelt -$can

erase .ov.plot all



set commandx [makecommand $functionx]
set commandy [makecommand $functiony]

set dx [expr double($xdelt/$maxsteps)]
set dy [expr double($ydelt/$maxsteps)]

set eps [expr 0.2*sqrt($dx*$dx+$dy*$dy)]

set t $t0
for {set i 0} {$i<=$maxsteps} {incr i} {
for {set j 0} {$j<=$maxsteps} {incr j} {

  set x [expr $xmin +$i*$dx]
  set y [expr $ymin +$j*$dy]


     if {[catch { expr double($commandx) } result]} {
    	textinfo "Fehler bei $x: $result"
	set xstrich 0
    } else {
    	set xstrich $result
    }

if {$xstrich=="Inf"} {set xstrich 99999}
if {$xstrich=="-Inf"} {set xstrich -99999}

     if {[catch { expr double($commandy) } result]} {
    	textinfo "Fehler bei $y: $result"
	set ystrich 0
    } else {
    	set ystrich $result
    }

if {$ystrich=="Inf"} {set ystrich 99999}
if {$ystrich=="-Inf"} {set ystrich -99999}


  #set xstrich [expr double($commandx)]
  #set ystrich [expr double($commandy)]


# L = sqrt(1+ystrich^2) Laenge der Stecke von (x,y) nach (x+1,y+yneu)

  set L [expr sqrt($xstrich*$xstrich+$ystrich*$ystrich)]

  if {$L != 0} {

     set x1 [expr $x -$eps*$xstrich/$L]
     set y1 [expr $y -$eps*$ystrich/$L]
     set x2 [expr $x +$eps*$xstrich/$L]
     set y2 [expr $y +$eps*$ystrich/$L]
  } else {
     set x1 $x
     set y1 [expr $y - $eps]
     set x2 $x
     set y2 [expr $y - $eps]
  }

if {$slopeplot==1} {
  .ov.plot create line [nnx $x1] [nny $y1] [nnx $x2] [nny $y2]\
                       -tag richt -fill $color -width $width
}

}
}

axes
.ov.plot create rect 120 20 380 80 -fill white -outline white -tag title

.ov.plot create text 125 25 -text "x'= $functionx"  -font $boldFontN -anchor w -tag title
.ov.plot create text 125 40 -text "y'= $functiony"  -font $boldFontN -anchor w -tag title
.ov.plot create text 125 70 -text "a=$a b=$b c=$c d=$d e=$e"  -font $boldFontN -anchor w -tag title
#.ov.plot create text 15 90 -text "($xmin,$xmax)x($ymin,$ymax)" -font $boldFontN -anchor w -tag title


#.ov.plot create rect 0 $can 60 [expr $can-20] -fill white -outline white -tag title
#.ov.plot create text 0 $can -text " $xmin,$ymin" -anchor sw -font $boldFontN -tag title

#.ov.plot create rect 0 0 30 20 -fill white -outline white -tag title
#.ov.plot create text 0 0 -text " $ymax" -anchor nw -font $boldFontN -tag title

#.ov.plot create rect $can $can [expr $can-30] [expr $can-20] -fill white -outline white -tag title
#.ov.plot create text $can $can -text " $xmax" -anchor se -font $boldFontN -tag title

}


